{{ sdram-40MHz-test.spin }}
CON
  _clkmode = XTAL1 + PLL16X
  _xinfreq = 5_000_000


OBJ
  vid : "sdram-40MHz"

VAR

  long randstate
  long scroll_on

  long sprite2 [32]
  long spritey [32]
  long vtab [32]
  long red, green, blue

PUB Main |  i, j, k, m, x, y, s, pageno
  vtab [0] := $01000300
  vtab [1] := $01800100
  vtab [2] := $00800180
  vtab [3] := $01400000

  repeat j from 0 to 31
    spritey [j] := $AAAAAAAA >> (j>>1<<1) | $55555555 << (j>>1<<1)
    sprite2 [j] := $99999999
  vid.Start
  vid.set_page (0)
  vid.set_display_offsets (0, 0)
  scroll_on := false

  vid.fill_rect (50, 0, 600, 50)
  vid.set_colour ($FF, $FF, $FF)
  stringy (100, 10, @welcome)
  waity

  randstate := CNT         ' dumb random generator for demo

  red := $FF
  green := $FF
  blue := $FF
  j := 0
  k := 0

  vid.set_colour (red, green, blue)
  vid.set_cliprect (0, 0, 800, 64<<9-1)
  waity
  repeat j from 0 to 63
      pageno := j
      vid.set_display_page (pageno)
      vid.set_colour (j<<2, j<<2, j<<2)
      vid.fill_rect (100, pageno<<9+80, 700, pageno<<9+400)
      vid.set_colour (pageno*9, pageno*13, pageno*17)
      repeat k from 0 to 479
        vid.draw_span (0, pageno<<9+k, 800-11*pageno-k/43)
      vid.set_colour (255, 255,255)
      stringy (0, pageno<<9, @pagestr)
      if pageno > 9
        vid.draw_glyph (64, pageno<<9, "0"+pageno/10)
        vid.draw_glyph (80, pageno<<9, "0"+pageno//10)
      else
        vid.draw_glyph (64, pageno<<9, "0"+pageno)

  vid.set_page (0)
  vid.set_cliprect (20, 20, 780, 550)
  clear
  waity
  test_lines
  waity
  test_circle
  waity

  psychadelic_circles
  waity

  repeat 1
    repeat i from 0 to 7
      k := 100*i
      repeat j from 0 to 256 step 4
        vid.set_colour ((i&1) * j, ((i>>1)&1) * j, ((i>>2)&1) * j)
        vid.fill_rect (k, j+100, k+99, j+103)

    repeat 3
      waity
    vid.set_colour (red, green, blue)
    repeat j from 1 to 700 step 32
      vid.fill_rect (j, 0, j+32, 480)
      red := (red+25) & $FF    ' change colour every so often
      green := (green+13) & $FF    ' change colour every so often
      vid.set_colour (red, green, blue)
    repeat j from 1 to 700 step 32
      label (10, 10+j)
    waity
    repeat j from 10 to 469 step 32
      vid.fill_rect (0, j, vid#WIDTH, j+5)  ' erase one page
      red := (red+25) & $FF    ' change colour every so often
      'vid.set_colour (red, green, blue)
    waity
    vid.set_colour (red, green, blue)
    repeat j from 10 to 469
      vid.draw_span (100, j, vid#WIDTH-200)  ' erase one page
      if (j & $1F) == 0
        blue := (blue+25) & $FF    ' change colour every so often
        vid.set_colour (red, green, blue)
      scrolly
    waity
    repeat j from 1 to 31
      vid.draw_span (104, j+40, j)
      vid.draw_span (180-j, j+40, j)
      vid.draw_span (304, j, j)
      vid.draw_span (380-j, j, j)
      scrolly
    waity

  waity

  vid.set_colour (255, 255, 0)
  vid.set_cliprect (32, 32, 768, 448)
  vid.fill_rect (1, 1, 799, 479)
  test_polygon
  repeat
    showall
    waity
    vid.set_page (1)
    vid.set_cliprect (0, 0, 600, 360)
    clear
    test_labels
    waity
    vid.set_page (2)
    vid.set_cliprect (200, 0, 800, 360)
    vid.fill_rect (200, 0, 800, 360)
    test_circle
    waity
    vid.set_page (3)
    vid.set_cliprect (0, 120, 600, 480)
    clear
    test_polygon
    waity
    vid.set_page (4)
    vid.set_cliprect (200, 120, 800, 480)
    clear
    psychadelic_circles
    waity
    vid.set_page (5)
    vid.set_cliprect (10, 10, 700, 380)
    clear
    test_glyphs
    waity
    vid.set_page (6)
    vid.set_cliprect (50, 50, 750, 430)
    clear
    test_rects
    waity
    vid.set_page (7)
    vid.set_cliprect (50, 50, 750, 430)
    clear
    test_lines
    waity
    scroll_on := !scroll_on
    if !scroll_on
      vid.set_display_offsets (0, 0)
    waity
    vid.set_page (0)
    clear
    test_circle

PRI  showall | i, del
    repeat i from 0 to 63
      vid.set_display_page (i)
      waitcnt (CNT + 10<<20)


PRI  test_glyphs | i, j, k, m
  m := 0
  repeat k from 0 to 12
    vid.set_colour (red+k, 0, blue+(k>>1))
    repeat i from 0 to 49
      vid.draw_glyph (i<<4, 1+(k<<5)+i, m & $FF)
      m ++
      scrolly

  waity
  repeat k from 0 to 60
    vid.set_colour (16 ^ (k<<26~>31), 16 ^ (k<<26~>31), 0)
    repeat j from 0 to 100
      vid.draw_glyph (random (784), random (480-32), random (256))
      scrolly

PRI  test_labels
  repeat 50
    label (random (600), random (400))
    scrolly
    vid.set_colour (red += 15, green += 87, blue += 44)

PRI  test_rects
  clear
  scrolly
  repeat 40
    blue := (blue+3) &  $FF
    vid.set_colour (red, green, blue)
    vid.fill_rect (random (400), random (200), 401+random (400), 201+random (200))
    scrolly
  waity
  clear
  scrolly
  repeat 30
    green := (green+13) &  $FF
    vid.set_colour (red, green, blue)
    vid.border_rect (random (400), random (200), 401+random (400), 201+random (200))
    scrolly
  green := (green+13) &  $FF
  vid.set_colour (red, green, blue)
  waity
  clear
  scrolly
  repeat 50
    red := (red+3) &  $FF
    vid.set_colour (red, green, blue)
    repeat 10
      vid.draw_rect (random (400), random (200), 401+random (400), 201+random (200))
    scrolly

PRI  psychadelic_circles | x, y, j,j2, s, k
  red := 0
  green := 255
  blue := 100
  repeat 7
    vid.set_colour (red+=25,0, blue)
    x := random (800)
    y := random (vid#HEIGHT)
    j := random (250)+1
    j2 := random (150)+1
    s := random (12)+7
    'vid.fill_ellipse (x, y, j, j2)

    repeat k from j to s step s
      vid.fill_circle (x, y, k) ' vid.fill_ellipse (x, y, k>>1, k)
      scrolly
      'vid.border_circle (x, y, k )
      vid.set_colour (red+=25, green-=10, blue += 17)
    x := random (800)
    y := random (vid#HEIGHT)
    repeat k from j to s step s
      vid.fill_ellipse (x, y, k, k>>1)
      scrolly
      'vid.border_circle (x, y, k )
      vid.set_colour (red+=25, green-=10, blue += 17)

PRI  clear
    vid.set_colour (0, 0, 0)
    vid.fill_rect (0, 0, 800, 480)

PRI  test_circle
  repeat 25
    vid.border_circle (random (700)+50, random (400)+40, (red & 63)+1 { random(200)+1} )
    scrolly
    red+=17
    blue-= 10
    vid.set_colour (red, green, blue)
    repeat 9
      vid.draw_circle (random (700)+50, random (400)+40, random(121)+1 )
      scrolly
    scrolly
  repeat 50
    vid.set_colour (red, green, blue)
    vid.border_circle (random (700)+50, random (400)+40, random(100)+1)
    scrolly
    vid.set_colour (255-red, 255-green, 255-blue)
    vid.border_circle (random (700)+50, random (400)+40, random(100)+1)
    scrolly

PRI  test_lines | i, x, y
  x := random (200)+300
  y := random (100)+190
  repeat i from 100 to 700 step 15
    vid.set_colour (red, green, blue)
    red += 5
    green -= 10
    blue += 9
    vid.draw_line (i, 50, x, y)
    vid.draw_line (i, 430, x, y)
  repeat i from 50 to 430 step 8
    vid.set_colour (red, green, blue)
    red += 5
    green -= 10
    blue += 9
    vid.draw_line (x, y, 100, i)
    vid.draw_line (x, y, 700, i)

PRI  test_polygon | j
  vid.set_colour ($FF^red, $FF^green, $FF^blue)
  repeat 30
    vid.draw_poly (4, @vtab)
    scrolly
    vtab [0] -= 15
    vtab [1] += 7
    vtab [2] -= $50000
    vtab [3] -= $F0000
    red += 35
    vid.set_colour ($FF^red, $FF^green, $FF^blue)

  waity

  repeat 10
    repeat j from 0 to 15
      vtab [j] := (random (500)-10) << 16 + ((random (900)-50) & $FFFF)
    vid.set_colour (red, green, blue)
    green += 12
    red -= 22
    blue += 7
    vid.fill_poly (16, @vtab)
    scrolly


PRI  waity | ts
  ts := CNT
  repeat
    scrolly
  until CNT - ts > clkfreq>>1

PRI  scrolly | phase
  if scroll_on
    phase :=  CNT << 3
    phase := CNT << 4 + sine (phase) << 23
    vid.set_display_offsets (sine (phase) >> 2, sine ($40000000 + phase) >> 2)

PRI  stringy (x, y, s)
  repeat until byte[s] == 0
   ' if s & 1
    '  vid.draw_invglyph (x, y, byte[s])
    'else
      vid.draw_glyph (x, y, byte[s])
    scrolly
    s++
    x+=16

PRI  label (x, y)
  stringy (x, y, @my_string)
  vid.draw_sprite(x+180, y, @spritey)
  vid.draw_sprite(x+212, y, @sprite2)

PRI  sine (i)
  i |= 1
  if i < 0
    return -sine(-i)
  if i => $40000000
    return sine ($80000000-i)
  return word [$E000][(i>>19) & $7FF] ~> 8


PRI  random (n)
  randstate := randstate * 537 + $43853988       ' totally guessed linear congruential parameters(!)
  return (randstate >> 10) // n

DAT
my_string     byte   "40MHz SDram",0
welcome       byte   "SDram graphics test patterns",0
pagestr       byte   "page",0

{{
////////////////////////////////////////////////////////////////////////////////////////////
//                                TERMS OF USE: MIT License
////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this
// software and associated documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
// FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
////////////////////////////////////////////////////////////////////////////////////////////
}}
